org.cpsolver.instructor.criteria

## Class BackToBack

- java.lang.Object
- - org.cpsolver.ifs.criteria.AbstractCriterion<TeachingRequest.Variable,TeachingAssignment>
  - - org.cpsolver.instructor.criteria.InstructorSchedulingCriterion
    - - org.cpsolver.instructor.criteria.BackToBack

- All Implemented Interfaces:
    CanHoldContext, HasAssignmentContext<TeachingRequest.Variable,TeachingAssignment,AbstractCriterion.ValueContext>, Criterion<TeachingRequest.Variable,TeachingAssignment>, ExtendedInfoProvider<TeachingRequest.Variable,TeachingAssignment>, InfoProvider<TeachingRequest.Variable,TeachingAssignment>, ModelListener<TeachingRequest.Variable,TeachingAssignment>

      public class BackToBack
      extends InstructorSchedulingCriterion

  Back to Back. This criterion counts how well are the back-to-back preferences that are set on an `Instructor` met (counting `Instructor.countBackToBacks(Assignment, TeachingAssignment, double, double)`).
  Version:
    IFS 1.3 (Instructor Sectioning)
    Copyright (C) 2016 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.cpsolver.ifs.criteria.AbstractCriterion

      `AbstractCriterion.ValueContext, AbstractCriterion.ValueUpdateType`

  - ### Field Summary

    - ### Fields inherited from class org.cpsolver.ifs.criteria.AbstractCriterion

      `iBest, iDebug, iWeight, sDoubleFormat, sPercentFormat`

    - ### Fields inherited from interface org.cpsolver.ifs.assignment.context.CanHoldContext

      `sMaxSize`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `BackToBack()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected double[]` | `computeBounds(Assignment<TeachingRequest.Variable,TeachingAssignment> assignment)` Compute bounds (bounds are being cached by default).
    `void` | `configure(DataProperties properties)` Configure the criterion if needed
    `String` | `getAbbreviation()` Abbreviated name of the criterion for `Object.toString()`.
    `double[]` | `getBounds(Assignment<TeachingRequest.Variable,TeachingAssignment> assignment, Collection<TeachingRequest.Variable> variables)` Value bounds (minimum and maximum) of the criterion on a part of the problem
    `double` | `getDifferentRoomWeight()` Different room weight
    `double` | `getDifferentTypeWeight()` Different instructional type weight
    `double` | `getValue(Assignment<TeachingRequest.Variable,TeachingAssignment> assignment, Collection<TeachingRequest.Variable> variables)` Value of a part of the problem (given by the collection of variables)
    `double` | `getValue(Assignment<TeachingRequest.Variable,TeachingAssignment> assignment, TeachingAssignment value, Set<TeachingAssignment> conflicts)` Value of a proposed assignment (including hard conflicts)
    `double` | `getWeightDefault(DataProperties config)` Defines default weight (when `AbstractCriterion.getWeightName()` parameter is not present in the criterion).

    - ### Methods inherited from class org.cpsolver.instructor.criteria.InstructorSchedulingCriterion

      `getAssignedInstructors, getInfo, getInfo, getInstructors`

    - ### Methods inherited from class org.cpsolver.ifs.criteria.AbstractCriterion

      `afterAssigned, afterUnassigned, beforeAssigned, beforeUnassigned, bestRestored, bestSaved, clearCache, constraintAdded, constraintRemoved, createAssignmentContext, getAssignmentContextReference, getBest, getBounds, getBounds, getBounds, getContext, getContext, getExtendedInfo, getModel, getName, getPerc, getPercentage, getPercRev, getValue, getValue, getValue, getValueUpdateType, getWeight, getWeightedBest, getWeightedValue, getWeightedValue, getWeightedValue, getWeightedValue, getWeightedValue, getWeightedValue, getWeightName, inc, inc, init, setAssignmentContextReference, setModel, setValueUpdateType, toString, variableAdded, variableRemoved`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### BackToBack

          public BackToBack()

  - ### Method Detail

    - #### configure

          public void configure(DataProperties properties)

      Description copied from interface: `Criterion`
      Configure the criterion if needed
      Specified by:
        `configure` in interface `Criterion<TeachingRequest.Variable,TeachingAssignment>`
      Overrides:
        `configure` in class `AbstractCriterion<TeachingRequest.Variable,TeachingAssignment>`
      Parameters:
        `properties` - configuration

    - #### getWeightDefault

          public double getWeightDefault(DataProperties config)

      Description copied from class: `AbstractCriterion`
      Defines default weight (when `AbstractCriterion.getWeightName()` parameter is not present in the criterion).
      Overrides:
        `getWeightDefault` in class `AbstractCriterion<TeachingRequest.Variable,TeachingAssignment>`
      Parameters:
        `config` - solver configuration
      Returns:
        default criterion weight value

    - #### getDifferentRoomWeight

          public double getDifferentRoomWeight()

      Different room weight
      Returns:
        penalty for teaching two back-to-back that are in different rooms

    - #### getDifferentTypeWeight

          public double getDifferentTypeWeight()

      Different instructional type weight
      Returns:
        penalty for teaching two back-to-back that are of different instructional type

    - #### getValue

          public double getValue(Assignment<TeachingRequest.Variable,TeachingAssignment> assignment,
                                 TeachingAssignment value,
                                 Set<TeachingAssignment> conflicts)

      Description copied from interface: `Criterion`
      Value of a proposed assignment (including hard conflicts)
      Parameters:
        `assignment` - current assignment
        `value` - given value
        `conflicts` - values conflicting with the given value
      Returns:
        change in this criterion value when assigned

    - #### computeBounds

          protected double[] computeBounds(Assignment<TeachingRequest.Variable,TeachingAssignment> assignment)

      Description copied from class: `AbstractCriterion`
      Compute bounds (bounds are being cached by default).
      Overrides:
        `computeBounds` in class `AbstractCriterion<TeachingRequest.Variable,TeachingAssignment>`
      Parameters:
        `assignment` - current assignment
      Returns:
        minimum and maximum of this criterion's value

    - #### getBounds

          public double[] getBounds(Assignment<TeachingRequest.Variable,TeachingAssignment> assignment,
                                    Collection<TeachingRequest.Variable> variables)

      Description copied from interface: `Criterion`
      Value bounds (minimum and maximum) of the criterion on a part of the problem
      Specified by:
        `getBounds` in interface `Criterion<TeachingRequest.Variable,TeachingAssignment>`
      Overrides:
        `getBounds` in class `AbstractCriterion<TeachingRequest.Variable,TeachingAssignment>`
      Parameters:
        `assignment` - current assignment
        `variables` - list of problem variables
      Returns:
        minimum and maximum of this criterion for the given sub-problem

    - #### getValue

          public double getValue(Assignment<TeachingRequest.Variable,TeachingAssignment> assignment,
                                 Collection<TeachingRequest.Variable> variables)

      Description copied from interface: `Criterion`
      Value of a part of the problem (given by the collection of variables)
      Specified by:
        `getValue` in interface `Criterion<TeachingRequest.Variable,TeachingAssignment>`
      Overrides:
        `getValue` in class `AbstractCriterion<TeachingRequest.Variable,TeachingAssignment>`
      Parameters:
        `assignment` - current assignment
        `variables` - list of problem variables
      Returns:
        value of the given variables

    - #### getAbbreviation

          public String getAbbreviation()

      Description copied from class: `AbstractCriterion`
      Abbreviated name of the criterion for `Object.toString()`.
      Overrides:
        `getAbbreviation` in class `AbstractCriterion<TeachingRequest.Variable,TeachingAssignment>`
      Returns:
        abbreviated name of the criterion